Constant nat : Type.
Constant int : Type.
Constant foo : int.
Constant zero : nat.
Constant succ : forall (x : nat), nat.
Constant x0 : nat.
Constant x1 : nat.
Constant ax : x0 = x1.

Define test : nat := 
    (fun (x : nat) => succ x)
      (case (inj2 foo in (nat+int))
	(fun (x : nat) => succ zero)
	(fun (x : int) => succ zero)).

Define test2 : nat :=
      (fun (y : nat) (h : y = x1) => succ y) x1 (refl x1).

Define eq_sym : 
	forall (x : nat) (y : nat), ((x = y) -> (y = x)) :=
	  fun (x : nat) (y : nat) (h : x = y) =>
	  (subst (fun (a : nat) => (a = x)) x y h (refl x)).

Define eq_tra :
       forall (x : nat) (y : nat) (z : nat), ((x = y) -> (y = z) -> (x = z)) :=
  fun (x : nat) (y : nat) (z : nat) (h0 : x = y) (h1 : y = z) =>
     (subst (fun (a : nat) => (a = z)) y x (eq_sym x y h0) h1).
